#include <stdlib.h>
#include <stdio.h>
#include "directory.h"
#include <string.h>
#include <ctype.h>
#include "xutil.h"
#include "config.h"
#include "ftn.h"
#include "scanout.h"
#include "lutil.h"

#ifndef PATH_MAX
#define PATH_MAX 512
#endif

extern int fakeoutbound;
#define FAKEOUT "ram1_pbox_out_"

typedef struct _strl {
        struct _strl *next;
        char *str;
        char *dom;
        int zone;
} strl;

static faddr addr = {
        NULL,
        0,0,0,0,
        NULL
};

static int scan_dir(int (*)(faddr*,char,int,char*),char*,int);
static int scan_dir(int (*fn)(faddr*,char,int,char*),char *dname,int ispoint)
{
        int rc=0;
        char fname[PATH_MAX];
        char flavor='?';
        DIR *dp=NULL;
        struct dirent *de;
        int isflo;
        char *ptr;

        debug(1,"enter scan_dir \"%s\" (%s)",S(dname),ispoint?"point":"node");

        if ((dp=opendir(dname)) == NULL)
        {
                debug(1,"outbound \"%s\" cannot be opened, proceed",S(dname));
                return 0;
        }

        while ((de=readdir(dp)))
        if (((strlen(de->d_name) == 17) &&    /* zzzz_nnnndddd.eee */
            (de->d_name[4] == '_') &&
            (strspn(de->d_name,"0123456789abcdefABCDEF") == 4)&&
            (de->d_name[13] == '.') &&
            (strspn(de->d_name+5,"0123456789abcdefABCDEF") == 8))
            ||
            ((strlen(de->d_name) == 21) &&    /* zzzz_nnnnddddpppp.eee */
            (de->d_name[4] == '_') &&
            (strspn(de->d_name,"0123456789abcdefABCDEF") == 4)&&
            (de->d_name[13] == '.') &&
            (strspn(de->d_name+5,"0123456789abcdefABCDEF") == 12)))
        {
                debug(1,"checking: \"%s\"",de->d_name);
                addr.point=0;
                strncpy(fname,dname,PATH_MAX-2);
                strcat(fname,"_");
                strncat(fname,de->d_name,PATH_MAX-strlen(fname)-2);
                if (strlen(de->d_name) == 21)
                   ptr = de->d_name+17;
                else
                   ptr = de->d_name+13;

                if ((strcasecmp(ptr,".out") == 0) ||
                    (strcasecmp(ptr,".cut") == 0) ||
                    (strcasecmp(ptr,".hut") == 0) ||
                    (strcasecmp(ptr,".opk") == 0) ||
                    (strcasecmp(ptr,".cpk") == 0) ||
                    (strcasecmp(ptr,".hpk") == 0) ||
                    (strcasecmp(ptr,".flo") == 0) ||
                    (strcasecmp(ptr,".clo") == 0) ||
                    (strcasecmp(ptr,".hlo") == 0) ||
                    (strcasecmp(ptr,".req") == 0))
                {
                        if (strlen(de->d_name) == 21)
                                sscanf(de->d_name+5,"%04x%04x%04x",
                                        &addr.net,&addr.node,&addr.point);
                        else
                                sscanf(de->d_name+5,"%04x%04x",
                                        &addr.net,&addr.node);
                        flavor=tolower(ptr+1);
                        if (flavor == 'f') flavor='o';
                        if (strcasecmp(ptr+2,"ut") == 0)
                                isflo=OUT_PKT;
                        else if (strcasecmp(ptr+2,"pk") == 0)
                                isflo=OUT_DIR;
                        else if (strcasecmp(ptr+2,"lo") == 0)
                                isflo=OUT_FLO;
                        else if (strcasecmp(ptr+1,"req") == 0)
                                isflo=OUT_REQ;
                        else
                                isflo=-1;
                        debug(1,"%s \"%s\"",
                                (isflo == OUT_FLO) ? "flo file" : "packet",
                                de->d_name);
                        if ((rc=fn(&addr,flavor,isflo,fname))) goto exout;
                }
                else if ((strncasecmp(ptr+1,"su",2) == 0) ||
                         (strncasecmp(ptr+1,"mo",2) == 0) ||
                         (strncasecmp(ptr+1,"tu",2) == 0) ||
                         (strncasecmp(ptr+1,"we",2) == 0) ||
                         (strncasecmp(ptr+1,"th",2) == 0) ||
                         (strncasecmp(ptr+1,"fr",2) == 0) ||
                         (strncasecmp(ptr+1,"sa",2) == 0))
                {
                        isflo=OUT_ARC;
                        if ((rc=fn(&addr,flavor,isflo,fname))) goto exout;
                        debug(1,"arcmail file \"%s\"",de->d_name);
                }
                else
                {
                        debug(1,"skipping \"%s\"",de->d_name);
                }
        }

exout:
        closedir(dp);
        return rc;
}

int scanout(int (*fn)(faddr*,char,int,char*))
{
        int rc=0;
        char fname[PATH_MAX];
        fa_list *dom;
        strl *doml=NULL,*tmp,**tmpd;
        char *p,*q;
        DIR *dp;
        struct dirent *de;

        if (fakeoutbound)
        {
                strcpy(fname,FAKEOUT);
                if (whoami->addr->domain)
                        strcat(fname,whoami->addr->domain);
                else
                        strcat(fname,"fidonet");
        }
        else
        {
                strncpy(fname,outbound,PATH_MAX-1);
        }
#ifndef QDOS
        if ((p=strrchr(fname,'/'))) *p='\0';
        else fname[0]='\0';
#endif
        if ((dp=opendir(fname)) == NULL)
        {
                logerr("$cannot open outbound directory \"%s\" for reading",
                        S(fname));
                return 1;
        }

        for (dom=nllist;dom;dom=dom->next)
        {
                debug(1,"checking domain %s",S(dom->addr->domain));
                if ((p=dom->addr->domain) == NULL) p=whoami->addr->domain;
                q=p;
                if (((p == NULL) || (whoami->addr->domain == NULL) ||
                     (strcasecmp(p,whoami->addr->domain) == 0)) &&
                    (!fakeoutbound))
                {
                        if (dom->addr->zone == 0)
                                dom->addr->zone=whoami->addr->zone;
                        if ((p=strrchr(outbound,'/'))) p++;
                        else p=outbound;
                }
                for (tmpd=&doml;*tmpd;tmpd=&((*tmpd)->next))
                        if (strcasecmp(p,(*tmpd)->str) == 0) break;
                if (*tmpd == NULL)
                {
                        *tmpd=(strl*)xmalloc(sizeof(strl));
                        (*tmpd)->next=NULL;
                        (*tmpd)->str=p;
                        (*tmpd)->dom=q;
                        (*tmpd)->zone=dom->addr->zone;
                }
        }

        while ((de=readdir(dp)))
        for (tmpd=&doml;*tmpd;tmpd=&((*tmpd)->next))
        {
#ifdef QDOS
                debug(1,"checking Outbound %s",S((*tmpd)->str));
                addr.domain=(*tmpd)->dom;
                addr.zone=(*tmpd)->zone;
                if ((rc=scan_dir(fn,S((*tmpd)->str),0))) goto exout;
#else
                debug(1,"checking directory %s against %s",
                        de->d_name,S((*tmpd)->str));
                if ((strncasecmp(de->d_name,(*tmpd)->str,strlen((*tmpd)->str)) == 0) &&
                    ((*(p=de->d_name+strlen((*tmpd)->str)) == '\0') ||
                     ((*p == '.') && (strlen(p+1) == 3) &&
                      (strspn(p+1,"01234567890abcdefABCDEF") == 3))))
                {
                        if (*p) sscanf(p+1,"%03x",&addr.zone);
                        else addr.zone=(*tmpd)->zone;
                        if (fakeoutbound)
                        {
                                strncpy(fname,FAKEOUT,PATH_MAX-2);
                        }
                        else
                        {
                                strncpy(fname,outbound,PATH_MAX-2);
                        }
                        if ((p=strrchr(fname,'/'))) *p='\0';
                        else p=fname+strlen(fname);
                        strcat(fname,"/");
                        strncat(fname,de->d_name,PATH_MAX-strlen(fname)-2);
                        addr.domain=(*tmpd)->dom;
                        if ((rc=scan_dir(fn,fname,0))) goto exout;
                }
                else
                {
                        debug(1,"skipping \"%s\"",de->d_name);
                }
#endif
        }

exout:
        closedir(dp);
        for (tmp=doml;tmp;tmp=doml)
        {
                doml=tmp->next;
                free(tmp);
        }
        return rc;
}

#ifdef TESTING

extern char *configname;
extern int readconfig();

int each(faddr*,char,int,char*);
int each(faddr *addr,char flavor,int isflo,char *name)
{
        debug(0,"addr \"%s\" flavor '%c', %s, name \"%s\"",
                ascfnode(addr,0xff),flavor,isflo?"flo":"pkt",name);
        return 0;
}

int main(argc,argv)
int argc;
char *argv[];
{
        int rc;

        if (argv[1]) configname=argv[1];
        else configname="config";
        if ((rc=readconfig()))
        {
                debug(0,"readconfig failed - %d",rc);
                return rc;
        }
        verbose=1<<6;

        rc=scanout(each);
        debug(0,"scanout rc=%d",rc);
        return rc;
}

#endif
